package com.jscape.inet.terminal.commands;

import com.jscape.inet.terminal.Screen.Cursor;
import com.jscape.inet.terminal.Terminal;

/**
 * This command causes a line feed or a new line operation.
 */
public class LFCommand
        implements ControlCommand {

    public static final String CANONICAL_FORM = "\012";
    private static final LFCommand INSTANCE = new LFCommand();

    //----------------------------------------------------------------------------

    /**
     * Returns one and only one instance of this type.
     *
     * @return one and only one instance of this type.
     */
    public static LFCommand getInstance() {
        return INSTANCE;
    }

    //----------------------------------------------------------------------------

    /**
     * Private constructor to prevent uncontrolled creation.
     */
    private LFCommand() {
    }

    //----------------------------------------------------------------------------

    /**
     * Executes command giving parameters and <code>Terminal</code> object.
     *
     * @param params   array of <code>int</code> command parametrs.
     * @param terminal target <code>Terminal</code> object.
     */
    public void execute(int[] params, Terminal terminal) {
        Cursor c = terminal.getScreen().getCursor();
        c.scrollUp();

        if (terminal.isLNMMode()) {
            c.moveHome();
        }
    }

    //----------------------------------------------------------------------------

    /**
     * Sends command to remote host.
     *
     * @param params   command parameters.
     * @param terminal target <code>Terminal</code> object to send command.
     */
    public void send(int[] params, Terminal terminal) {
        terminal.send(CANONICAL_FORM);
    }

}
